import { AtomicPromise } from 'spica/promise';
export declare const currentTarget: unique symbol;
declare global {
    interface Event {
        [currentTarget]?: Event['currentTarget'];
    }
}
export declare function listen<T extends keyof WindowEventMap>(target: Window, type: T, listener: (ev: WindowEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function listen<T extends keyof WindowEventMap>(target: Window, selector: string, type: T, listener: (ev: WindowEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function listen<T extends keyof DocumentEventMap>(target: Document | ShadowRoot, type: T, listener: (ev: DocumentEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function listen<T extends keyof DocumentEventMap>(target: Document | ShadowRoot, selector: string, type: T, listener: (ev: DocumentEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function listen<T extends keyof HTMLElementEventMap>(target: HTMLElement, type: T, listener: (ev: HTMLElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function listen<T extends keyof HTMLElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, listener: (ev: HTMLElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function listen<T extends keyof SVGElementEventMap>(target: SVGElement, type: T, listener: (ev: SVGElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function listen<T extends keyof SVGElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, listener: (ev: SVGElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function listen<T extends keyof MathMLElementEventMap>(target: MathMLElement, type: T, listener: (ev: MathMLElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function listen<T extends keyof MathMLElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, listener: (ev: MathMLElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function listen<T extends keyof ElementEventMap>(target: Element, type: T, listener: (ev: ElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function listen<T extends keyof ElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, listener: (ev: ElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function once<T extends keyof WindowEventMap>(target: Window, type: T, option?: boolean | AddEventListenerOptions): AtomicPromise<WindowEventMap[T]>;
export declare function once<T extends keyof WindowEventMap>(target: Window, type: T, listener: (ev: WindowEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function once<T extends keyof WindowEventMap>(target: Window, selector: string, type: T, option?: boolean | AddEventListenerOptions): AtomicPromise<WindowEventMap[T]>;
export declare function once<T extends keyof WindowEventMap>(target: Window, selector: string, type: T, listener: (ev: WindowEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function once<T extends keyof DocumentEventMap>(target: Document | ShadowRoot, type: T, option?: boolean | AddEventListenerOptions): AtomicPromise<DocumentEventMap[T]>;
export declare function once<T extends keyof DocumentEventMap>(target: Document | ShadowRoot, type: T, listener: (ev: DocumentEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function once<T extends keyof DocumentEventMap>(target: Document | ShadowRoot, selector: string, type: T, option?: boolean | AddEventListenerOptions): AtomicPromise<DocumentEventMap[T]>;
export declare function once<T extends keyof DocumentEventMap>(target: Document | ShadowRoot, selector: string, type: T, listener: (ev: DocumentEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function once<T extends keyof HTMLElementEventMap>(target: HTMLElement, type: T, option?: boolean | AddEventListenerOptions): AtomicPromise<HTMLElementEventMap[T]>;
export declare function once<T extends keyof HTMLElementEventMap>(target: HTMLElement, type: T, listener: (ev: HTMLElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function once<T extends keyof HTMLElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, option?: boolean | AddEventListenerOptions): AtomicPromise<HTMLElementEventMap[T]>;
export declare function once<T extends keyof HTMLElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, listener: (ev: HTMLElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function once<T extends keyof SVGElementEventMap>(target: SVGElement, type: T, option?: boolean | AddEventListenerOptions): AtomicPromise<SVGElementEventMap[T]>;
export declare function once<T extends keyof SVGElementEventMap>(target: SVGElement, type: T, listener: (ev: SVGElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function once<T extends keyof SVGElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, option?: boolean | AddEventListenerOptions): AtomicPromise<SVGElementEventMap[T]>;
export declare function once<T extends keyof SVGElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, listener: (ev: SVGElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function once<T extends keyof MathMLElementEventMap>(target: MathMLElement, type: T, option?: boolean | AddEventListenerOptions): AtomicPromise<MathMLElementEventMap[T]>;
export declare function once<T extends keyof MathMLElementEventMap>(target: MathMLElement, type: T, listener: (ev: MathMLElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function once<T extends keyof MathMLElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, option?: boolean | AddEventListenerOptions): AtomicPromise<MathMLElementEventMap[T]>;
export declare function once<T extends keyof MathMLElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, listener: (ev: MathMLElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function once<T extends keyof ElementEventMap>(target: Element, type: T, option?: boolean | AddEventListenerOptions): AtomicPromise<ElementEventMap[T]>;
export declare function once<T extends keyof ElementEventMap>(target: Element, type: T, listener: (ev: ElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function once<T extends keyof ElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, option?: AddEventListenerOptions): AtomicPromise<ElementEventMap[T]>;
export declare function once<T extends keyof ElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, listener: (ev: ElementEventMap[T]) => void, option?: AddEventListenerOptions): () => undefined;
export declare function delegate<T extends keyof WindowEventMap>(target: Window, selector: string, type: T, listener: (ev: WindowEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function delegate<T extends keyof DocumentEventMap>(target: Document | ShadowRoot, selector: string, type: T, listener: (ev: DocumentEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function delegate<T extends keyof HTMLElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, listener: (ev: HTMLElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function delegate<T extends keyof SVGElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, listener: (ev: SVGElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function delegate<T extends keyof MathMLElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, listener: (ev: MathMLElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function delegate<T extends keyof ElementEventMap>(target: Document | ShadowRoot | Element, selector: string, type: T, listener: (ev: ElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function bind<T extends keyof WindowEventMap>(target: Window, type: T, listener: (ev: WindowEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function bind<T extends keyof DocumentEventMap>(target: Document | ShadowRoot, type: T, listener: (ev: DocumentEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function bind<T extends keyof HTMLElementEventMap>(target: HTMLElement, type: T, listener: (ev: HTMLElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function bind<T extends keyof SVGElementEventMap>(target: SVGElement, type: T, listener: (ev: SVGElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function bind<T extends keyof MathMLElementEventMap>(target: MathMLElement, type: T, listener: (ev: MathMLElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
export declare function bind<T extends keyof ElementEventMap>(target: Element, type: T, listener: (ev: ElementEventMap[T]) => void, option?: boolean | AddEventListenerOptions): () => undefined;
